#property copyright "Entry Drive (c) HotFx 2012.01.17"
#property link "http://hot-fx.blogspot.com" // http://hotfx.0pk.ru
//--- order parameters
extern bool   MarketExec  = TRUE;
extern double StopLoss    = 10.0;
extern double FixedLot    = 0.01;
extern double Risk        = 5;
extern int    slippage    = 1;
extern int    magicnum    = 123;
extern double MaxSpread   = 3;
extern color  Bcol        = Blue;
extern color  Scol        = Red;
//--- other
int retry = 3, delay = 1000, per, x1 = 20, y1 = 20, x2 = 20, y2 = 63, x3 = 20, y3 = 106, x4 = 100, y4 = 59;
double ab, diff, PosL, NewL, MyPoint, ABG = 0, MinLot, MaxLot, LotDigits, Kontr;
bool bys = FALSE, ses = FALSE, csw = FALSE, tchSL = FALSE; string symb;

void init()
 {
  MyPoint = Point; if (Digits == 5 || Digits == 3) { MyPoint *= 10; slippage *= 10; }
  StopLoss *= MyPoint; symb = Symbol(); if (ABG == 0) ABG = AccountBalance();
  MinLot = MarketInfo(symb, MODE_MINLOT); MaxLot = MarketInfo(symb, MODE_MAXLOT);
  LotDigits = MathLog(MarketInfo(symb, MODE_LOTSTEP)) / MathLog(0.1); Kontr = MarketInfo(symb, MODE_LOTSIZE);
  
  if (ObjectFind("SL") != -1) PosL = ObjectGet("SL",OBJPROP_PRICE1);
  else { PosL = Close[0]; ObjectCreate("SL", OBJ_HLINE, 0, 0, PosL); }
  ObjectSet("SL", OBJPROP_STYLE, STYLE_DOT);
  ObjectSet("SL", OBJPROP_COLOR, Gold);

  ObjectCreate("tDOIT", OBJ_LABEL, 0, 0, 0);
  ObjectSet("tDOIT", OBJPROP_COLOR, Gray);
  ObjectSet("tDOIT", OBJPROP_CORNER, 1);
  ObjectSet("tDOIT", OBJPROP_XDISTANCE, x4);
  ObjectSet("tDOIT", OBJPROP_YDISTANCE, y4);
  ObjectSetText("tDOIT", "DO IT! <<", 17, "Impact");

  ObjectCreate("tBUY", OBJ_LABEL, 0, 0, 0);
  ObjectSet("tBUY", OBJPROP_COLOR, Blue);
  ObjectSet("tBUY", OBJPROP_CORNER, 1);
  ObjectSet("tBUY", OBJPROP_XDISTANCE, x1);
  ObjectSet("tBUY", OBJPROP_YDISTANCE, y1);
  ObjectSetText("tBUY", "[ BUY ]", 14, "Impact");

  ObjectCreate("tCLOSE", OBJ_LABEL, 0, 0, 0);
  ObjectSet("tCLOSE", OBJPROP_COLOR, Gold);
  ObjectSet("tCLOSE", OBJPROP_CORNER, 1);
  ObjectSet("tCLOSE", OBJPROP_XDISTANCE, x2);
  ObjectSet("tCLOSE", OBJPROP_YDISTANCE, y2);
  ObjectSetText("tCLOSE", "( CLOSE )", 14, "Impact");
  
  ObjectCreate("tSELL", OBJ_LABEL, 0, 0, 0);
  ObjectSet("tSELL", OBJPROP_COLOR, Red);
  ObjectSet("tSELL", OBJPROP_CORNER, 1);
  ObjectSet("tSELL", OBJPROP_XDISTANCE, x3);
  ObjectSet("tSELL", OBJPROP_YDISTANCE, y3);
  ObjectSetText("tSELL", "[ SELL ]", 14, "Impact");

  ObjectCreate("tAP", OBJ_LABEL, 0, 0, 0);
  ObjectSet("tAP", OBJPROP_COLOR, Black);
  ObjectSet("tAP", OBJPROP_CORNER, 1);
  ObjectSet("tAP", OBJPROP_XDISTANCE, x3);
  ObjectSet("tAP", OBJPROP_YDISTANCE, y3 + 37);
  
  per = Period(); ab = AccountBalance(); diff = 0;
 } 

void start()
 {
  if (ObjectGet("tDOIT",OBJPROP_XDISTANCE) != x4 || ObjectGet("tDOIT",OBJPROP_YDISTANCE) != y4 || ObjectGet("tDOIT",OBJPROP_COLOR) != Gray)
   { ObjectSet("tDOIT", OBJPROP_XDISTANCE, x4); ObjectSet("tDOIT", OBJPROP_YDISTANCE, y4); ObjectSet("tDOIT", OBJPROP_COLOR, Gray); }

  double spread = (Ask - Bid) / MyPoint; if (spread > MaxSpread) ObjectSet("tDOIT", OBJPROP_COLOR, DarkOrange);
  
  double LotSize = FixedLot; if (LotSize == 0) LotSize = AccountFreeMargin() * Risk / Kontr;
  LotSize = NormalizeDouble(MathMax(MinLot, MathMin(LotSize, MaxLot)), LotDigits);

  if (ObjectGet("SL",OBJPROP_PRICE1) != PosL)
   { tchSL = TRUE; NewL = ObjectGet("SL",OBJPROP_PRICE1); ObjectSet("SL",OBJPROP_PRICE1, PosL); }
   
  if (ObjectGet("SL",OBJPROP_PRICE1) == PosL && tchSL)
   { 
    tchSL = FALSE; ObjectSet("tDOIT", OBJPROP_COLOR, Lime);
    for (int i = OrdersTotal() - 1; i >= 0; i --) if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
     {
      if (OrderSymbol() != symb || OrderMagicNumber() != magicnum) continue;
      for (int j = 1; j <= retry; j ++)
       {
        WaitFlow();
        if (OrderModify(OrderTicket(), OrderOpenPrice(), ND(NewL), OrderTakeProfit(), 0, -1)) break;
        int err = GetLastError(); if (!(err == 4 || err == 137 || err == 146 || err == 136)) break;
                               //SERVER_BUSY/BROKER_BUSY/TRADE_CONTEXT_BUSY/OFF_QUOTES
        Sleep(delay);                          
       } //retry
     } //Orders
    ObjectSet("SL",OBJPROP_PRICE1, NewL); PosL = NewL;
   }

  if (ObjectGet("tBUY", OBJPROP_XDISTANCE) != x1 || ObjectGet("tBUY", OBJPROP_YDISTANCE) != y1)
   { bys = TRUE; ObjectSet("tBUY", OBJPROP_XDISTANCE, x1); ObjectSet("tBUY", OBJPROP_YDISTANCE, y1); }
   
  if (ObjectGet("tBUY", OBJPROP_XDISTANCE) == x1 && ObjectGet("tBUY", OBJPROP_YDISTANCE) == y1 && bys)
   { 
    bys = FALSE; ObjectSet("tDOIT", OBJPROP_COLOR, Lime);
    for (i = 1; i <= retry; i ++)
     {
      WaitFlow();
      if (MarketExec) { if (OrderSend(symb, OP_BUY, LotSize, ND(Ask), slippage, 0, 0, "", magicnum, 0, Bcol) != -1) break; }
      else
       {
        double tmp = ND(Ask - StopLoss);
        if (OrderSend(symb, OP_BUY, LotSize, ND(Ask), slippage, tmp, 0, "", magicnum, 0, Bcol) != -1)
         { PosL = tmp; ObjectSet("SL",OBJPROP_PRICE1, PosL); break; }
       }
      err = GetLastError(); if (!(err == 4 || err == 137 || err == 146 || err == 136)) break;
                             //SERVER_BUSY/BROKER_BUSY/TRADE_CONTEXT_BUSY/OFF_QUOTES
      Sleep(delay);                          
     }
   }

  if (ObjectGet("tSELL", OBJPROP_XDISTANCE) != x3 || ObjectGet("tSELL",OBJPROP_YDISTANCE) != y3)
   { ses = TRUE; ObjectSet("tSELL", OBJPROP_XDISTANCE, x3); ObjectSet("tSELL", OBJPROP_YDISTANCE, y3); }

  if (ObjectGet("tSELL", OBJPROP_XDISTANCE) == x3 && ObjectGet("tSELL", OBJPROP_YDISTANCE) == y3 && ses)
   { 
    ses = FALSE; ObjectSet("tDOIT", OBJPROP_COLOR, Lime);
    for (i = 1; i <= retry; i ++)
     {
      WaitFlow();
      if (MarketExec) { if (OrderSend(symb, OP_SELL, LotSize, ND(Bid), slippage, 0, 0, "", magicnum, 0, Scol) != -1) break; }
      else
       {
        tmp = ND(Bid + StopLoss);
        if (OrderSend(symb, OP_SELL, LotSize, ND(Bid), slippage, tmp, 0, "", magicnum, 0, Scol) != -1)
         { PosL = tmp; ObjectSet("SL",OBJPROP_PRICE1, PosL); break; }
       }
      err = GetLastError(); if (!(err == 4 || err == 137 || err == 146 || err == 136)) break;
      Sleep(delay);                          
     }
   }

  double ap = 0; double ostl = 0;
  for (i = OrdersTotal() - 1; i >= 0; i --) if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
   {
    if (OrderSymbol() != symb || OrderMagicNumber() != magicnum) continue;
    double otyp = OrderType(), oprc = OrderOpenPrice(); ostl = OrderStopLoss();
    if (otyp == OP_BUY) { ap = ap + Bid - oprc; tmp = Ask - StopLoss; }
    if (otyp == OP_SELL) { ap = ap + oprc - Ask; tmp = Bid + StopLoss; }
    if (ostl == 0 &&  StopLoss != 0)
     if (OrderModify(OrderTicket(), oprc, ND(tmp), OrderTakeProfit(), 0, -1))
      { PosL = tmp; ObjectSet("SL",OBJPROP_PRICE1, PosL); ostl = tmp; }
    if (ostl != 0) ostl = (ostl - oprc) / MyPoint;
   } 
  ap /= MyPoint;
   
  if (ObjectGet("tCLOSE", OBJPROP_XDISTANCE) != x2 || ObjectGet("tCLOSE", OBJPROP_YDISTANCE) != y2)
   { csw = TRUE; ObjectSet("tCLOSE", OBJPROP_XDISTANCE, x2); ObjectSet("tCLOSE", OBJPROP_YDISTANCE, y2); }
   
  if (ObjectGet("tCLOSE", OBJPROP_XDISTANCE) == x2 && ObjectGet("tCLOSE", OBJPROP_YDISTANCE) == y2 && csw)
   { 
    csw = FALSE; ObjectSet("tDOIT", OBJPROP_COLOR, Lime); bool repC = true;
    while (repC)
     {
      repC = false; WaitFlow();
      for (i = OrdersTotal() - 1; i >= 0; i --) if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
       {
        if (OrderSymbol() != symb || OrderMagicNumber() != magicnum) continue;
        if (OrderType() == OP_BUY) if (!OrderClose(OrderTicket(), OrderLots(), ND(Bid), slippage, Bcol)) repC = true;
        if (OrderType() == OP_SELL) if (!OrderClose(OrderTicket(), OrderLots(), ND(Ask), slippage, Scol)) repC = true; 
       }
     } 
    ap = 0;
   }
   
  ObjectSetText("tAP", DoubleToStr(ap, 1), 19, "Impact");
  if (ap < 0) ObjectSet("tAP", OBJPROP_COLOR, DarkOrange);
  else ObjectSet("tAP", OBJPROP_COLOR, Lime);
 
  double acEQ = AccountEquity(); tmp = AccountBalance(); if (ab != tmp) { diff = tmp - ab; ab = tmp; }
  
  if (tmp > ABG) ABG = tmp;

  Comment("\n ", symb, "-", per, "     ab ", tmp, "     lst ", diff, "     cr% ", MathRound(acEQ / ABG * 100),
          "     lot  ", LotSize, "     sl ", ostl, "     eq ", acEQ, "     ap ", AccountProfit(), "     sp ", spread);
 } //start

double ND(double value) { return (NormalizeDouble(value, Digits)); }

void WaitFlow() { RefreshRates(); while (IsTradeContextBusy()) { Sleep(100); RefreshRates(); } }

